#include <oxstd.h>
#include <oxprob.h>
#include "D:\\work\\My Programs\\ivqr\\webexample\\iqr.ox"
#include "D:\\work\\My Programs\\ivqr\\webexample\\vciqr.ox"
#include "D:\\work\\My Programs\\ivqr\\webexample\\vcqr.ox"

main(){
// This sample illustrates how to obtain estimates for a single quantile.


	decl bqr50, biqr50, A, out, j;	// NOTE:  All variables used in a program must be declared.

	decl data = loadmat("D:\\work\\My Programs\\ivqr\\webexample\\jtpa_mw.raw");
		// Load data matrix (Note: In Ox, the first line of the data file must have the
		// number of rows and columns of the data matrix.  See jtpa_mw.raw.)
		
	decl y = data[][0];        // Name variables.  NOTE: Ox starts indexing with 0 not 1.
	decl d = data[][1];
	decl x = data[][2:14];
	decl z = data[][15];

	decl w = z~x~ones(rows(d),1);			
	decl dhat = w*invertsym(w'*w)*(w'*d);	// Generate the linear projection of
					// the RHS endogenous vector on {Z,X} to use the instrument.

	delete w, data;				// Clear out unnecessary variables

	out = rq(d~x,y,.50,0);      // Estimate the median using quantile regression
	println(out);
	bqr50 = kcov_qr(out,.50,y,d~x);  // Obtain standard errors

	println("50th percentile -- Quantile Regression");
	println(bqr50[0]);			// Display coefficient estimates.
								// Note that coefficients are saved (and printed) in the same
								// order they are entered (e.g. In this case, the coeff on
								// d is first, followed by the coefs on x in the order
								// their columns come in the matrix x.) with the constant
								// last.


	A = range(-500,1500,10);				// Generate grid search region for instrumental quantile regression

	out = iqr(y,d,x,dhat,.50,A',0);  // Get instrumental quantile regression estimates
	biqr50 = kcov_iqr(out[0],.50,y,d,x,z);
	
	println("50th percentile --  Instrumental Quantile Regression");
	println(biqr50[0]);			// Display coefficient estimates.
								// Note that coefficients on the x variables are saved
								// (and printed) in the same order they are entered.
								// The treatment (d) is always first, and the constant
								// is always last.


//	savemat("C:\\research\\iqr_1\\bqr50.xls" , bqr50[0]);	  // Save results if desired
//	savemat("C:\\research\\iqr_1\\vcqr50.xls" , bqr50[1]);
//	savemat("C:\\research\\iqr_1\\Jqr50.xls" , bqr50[2]);
//	savemat("C:\\research\\iqr_1\\biqr50.xls" , biqr50[0]);
//	savemat("C:\\research\\iqr_1\\vciqr50.xls" , biqr50[1]);
//	savemat("C:\\research\\iqr_1\\Jiqr50.xls" , biqr50[2]);
	
}		